using Microsoft.Web.WebView2.Core;

namespace EdgeVoyager
{
    public partial class Form1 : Form
    {
        int zoom = 100;
        public Form1()
        {
            InitializeComponent();
            InitializeAsync();
        }

        async void InitializeAsync()
        {
            await webView21.EnsureCoreWebView2Async(null);
            webView21.CoreWebView2.Navigate("https://cn.bing.com/?mkt=zh-CN");
        }

        private void back_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoBack();
        }

        private void forward_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoForward();
        }

        private void refresh_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Reload();
        }

        private void stop_button_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Stop();
        }

        private void search_button_Click(object sender, EventArgs e)
        {

        }

        private void webView21_NavigationStarting(object sender, CoreWebView2NavigationStartingEventArgs e)
        {
            int num = 0;
            string currentUrl = webView21.Source.ToString();
            if (!comboBox1.Items.Contains(currentUrl))
            {
                comboBox1.Items.Add(currentUrl);
            }
            comboBox1.Text = currentUrl;
            progressBar.Value = 0;
            progressLabel.Text = "0%";
            StatusLabel.Text = "ʼ" + currentUrl; 
            if (num != 0)
            {
                Form1 newForm = new Form1();

                // ȴ´ڵWebView2ؼʼ
                newForm.webView21.CoreWebView2InitializationCompleted += (s, args) =>
                {
                    if (args.IsSuccess)
                    {
                        // ´WebView2ؼĵĿΪǰҪ򿪵URL
                        newForm.webView21.CoreWebView2.Navigate(e.Uri);
                    }
                    else
                    {
                        // ʼʧܣԽӦĴ
                        MessageBox.Show("WebView2ʼʧܣ" + args.InitializationException.Message);
                    }
                };

                // ʾ´
                newForm.Show();

                // ȡǰĵ
                e.Cancel = true;
            }
        }

        private async void webView21_NavigationCompleted(object sender, CoreWebView2NavigationCompletedEventArgs e)
        {
            string currentUrl = webView21.Source.ToString();
            if (!comboBox1.Items.Contains(currentUrl))
            {
                comboBox1.Items.Add(currentUrl);
            }
            comboBox1.Text = currentUrl;
            progressBar.Value = 100;
            progressLabel.Text = "100%";
            StatusLabel.Text = "ɡ"; 
            string title = await webView21.CoreWebView2.ExecuteScriptAsync("document.title;");
            this.Text = "LYKNS EdgeVoyager" + title.Trim('"');
        }

        private void comboBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                string url = comboBox1.Text;
                if (Uri.IsWellFormedUriString(url, UriKind.Absolute))
                {
                    webView21.CoreWebView2.Navigate(url);
                }
                else
                {
                    MessageBox.Show("Чַ", "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void ˳XToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Environment.Exit(0);
        }

        private void webView21_ContentLoading(object sender, CoreWebView2ContentLoadingEventArgs e)
        {
            progressBar.Value = 50; // ʱΪ50%
            progressLabel.Text = "50%";
            StatusLabel.Text = "ݿʼ";
        }
        private async void SetZoomLevel(double zoomLevel)
        {
            await webView21.CoreWebView2.ExecuteScriptAsync($"document.body.style.zoom = '{zoomLevel}%'");
        }

        private void toolStripSplitButton1_ButtonClick(object sender, EventArgs e)
        {
            SetZoomLevel(100);
            toolStripMenuItem3.Enabled = true;
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            zoom = zoom + 25;
            SetZoomLevel(zoom);
            toolStripMenuItem3.Enabled = true;
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            zoom = zoom - 25;
            SetZoomLevel(zoom);
            if (zoom == 25)
                toolStripMenuItem3.Enabled = false;
        }

        private void ˢRToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Reload();
        }

        private void ֹͣTToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.Stop();
        }

        private void ǰQToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoForward();
        }

        private void WToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView21.CoreWebView2.GoBack();
        }
    }
}
